/*!
 * Copyright (c) 2019 han_feng@foxmail.com
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
 * OR OTHER DEALINGS IN THE SOFTWARE.
 */
import Vue from"vue";import createVuexAlong from"vuex-along";import router from"./router";import store from"./store";const HOOK_KEYS=Object.freeze({beforeEach:!0,beforeResolve:!0,afterEach:!0,onReady:!0,onError:!0});function addVuexModules(e){const o=e.getApplication(),t={name:`VAS:${o.name}-${o.version}`},r=[],n=[],s=e.getExtension("vuex.modules");for(const e of Object.keys(s)){const o=s[e];store.registerModule(e,o),o.storage&&("session"===o.storage?n.push(e):"local"===o.storage&&r.push(e))}n.length>0&&(t.session={list:n}),r.length>0?t.local={list:r}:t.justSession=!0,createVuexAlong(t)(store)}function addPlugins(e){const o=e.getExtensions("vue.plugins");null!==o&&o.forEach(e=>Vue.use(e))}function addRoutes(e){const o=e.getExtension("vue.router.routes"),t=[],r={},n={};if(null!==o){o.forEach(e=>{if(e&&e.parent&&e.routes){const o=e.parent;let s;"root"===o?s=t:void 0===(s=r[o])&&(n[o]=n[o]||[],s=n[o]),e.routes.forEach(e=>{s.push(e),function e(o){if(void 0!==o.children&&Array.isArray(o.children)){const t=o.name;if(void 0===t||""===t)return void console.log(`Error: 路由名称未定义，${JSON.stringify(o)}`);const s=o.children;r[t]=s,n[t]&&(n[t].forEach(e=>{s.push(e)}),delete n[t]),o.children.forEach(o=>{e(o)})}}(e)})}});for(const e of Object.keys(n))console.log(`Error: 父路由“${e}”不存在`);router.addRoutes(t),e.setAttribute("vue.routes",t)}}function addRouterHooks(e){const o=e.getExtensions("vue.router.hooks");if(null!==o){const e=router;o.forEach(o=>{for(const t in o)void 0!==HOOK_KEYS[t]&&e[t](o[t])})}}function createVueInstance(e){const o=e.getExtension("vue.app"),t=o.component||{name:"app",render:e=>e("router-view")},r={router:router,store:store,render:e=>e(t)},n=e.getExtensions("vue.options");null!==n&&(r.mixins=n);const s=new Vue(r),u=o.element||"#app";s.$mount(u),e.setAttribute("vue.instance",s)}const activator={start(e){addVuexModules(e),addPlugins(e),addRoutes(e),addRouterHooks(e),createVueInstance(e)}};export default activator;